/*
		Widget Maker - A widget construction tool.
		Copyright © 2004-2007 Harry Whitfield

		This program is free software; you can redistribute it and/or modify it
		under the terms of the GNU General Public License as published by the
		Free Software Foundation; either version 2 of the License, or (at your
		option) any later version.

		This program is distributed in the hope that it will be useful, but
		WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		General Public License for more details.

		You should have received a copy of the GNU General Public License along
		with this program; if not, write to the Free Software Foundation, Inc.,
		51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
		Widget Maker - version 2.3
		22 August, 2007
		Copyright 2004-2007 Harry Whitfield
		mailto:g6auc@arrl.net
	*/

		var buttonsEnabled = true;
		var editDisabled   = true;
		var sem = "";
		
		var aboutStr = "";
		var actionStr = "";
		var canvasStr = "";
		var frameStr  = "";
		var hotkeyStr = "";
		var imageStr = "";
		var prefStr = "";
		var prefGroupStr = "";
		var scrollBarStr = "";
		var settingsStr = "";
		var textAreaStr = "";
		var textStr = "";
		var timerStr = "";
		var widgetStr = "";
		var windowStr = "";
		
		var contextStr = "";
		var shadowStr = "";
		
		var fragmentStr = "";
		var fragmentType = "invalid";
		var fragmentAppend  = true;

		var saveStr = "";
		var extraTab = "";
		var windowDefOpen = false;
		var frameDefOpen  = 0;

		var gWidth = "";
		var gHeight = "";
		var gPathName = "";
		var gActionStr = "";
		
		var saveFragment = true;
		
		var gAttribute  = (preferences.attributePref.value == "1");
		var gHorizontal = (preferences.separatorPref.value == "1");

		// The following flags control printing in the debug console window
		
		var eFlag = false;	// show information about files dropped on the about and image buttons
							// and use of GraphicConverter
							
		var mFlag = true;	// show generated xml as it is produced
		var sFlag = false;	// show applescripts
		var lFlag = false;	// log runCommand() and appleScript() calls

		function outputFragments()
		{
			if (!saveFragment) { monitor.data = ""; fragmentStr = ""; saveFragment = true; return; }
			
			fragmentStr = monitor.data;
			
			switch(fragmentType)
			{
				case 'about':		if (fragmentAppend) { aboutStr     += fragmentStr; } else { aboutStr     = fragmentStr; } break;
				case 'action':		if (fragmentAppend) { actionStr    += fragmentStr; } else { actionStr    = fragmentStr; } break;
				case 'canvas':		if (fragmentAppend) { canvasStr    += fragmentStr; } else { canvasStr    = fragmentStr; } break;
				case 'frame':		if (fragmentAppend) { frameStr     += fragmentStr; } else { frameStr     = fragmentStr; } break;
				case 'hotkey':		if (fragmentAppend) { hotkeyStr    += fragmentStr; } else { hotkeyStr    = fragmentStr; } break;
				case 'image':		if (fragmentAppend) { imageStr     += fragmentStr; } else { imageStr     = fragmentStr; } break;
				case 'pref':		if (fragmentAppend) { prefStr      += fragmentStr; } else { prefStr      = fragmentStr; } break;
				case 'prefGroup':	if (fragmentAppend) { prefGroupStr += fragmentStr; } else { prefGroupStr = fragmentStr; } break;
				case 'scrollBar':	if (fragmentAppend) { scrollBarStr += fragmentStr; } else { scrollBarStr = fragmentStr; } break;
				case 'settings':	if (fragmentAppend) { settingsStr  += fragmentStr; } else { settingsStr  = fragmentStr; } break;
				case 'text':		if (fragmentAppend) { textStr      += fragmentStr; } else { textStr      = fragmentStr; } break;
				case 'textArea':	if (fragmentAppend) { textAreaStr  += fragmentStr; } else { textAreaStr  = fragmentStr; } break;
				case 'timer':		if (fragmentAppend) { timerStr     += fragmentStr; } else { timerStr     = fragmentStr; } break;
				case 'widget':		if (fragmentAppend) { widgetStr    += fragmentStr; } else { widgetStr    = fragmentStr; } break;
				case 'window':		if (fragmentAppend) { windowStr    += fragmentStr; } else { windowStr    = fragmentStr; } break;
				default: break;
			}
			
			monitor.data = ""; fragmentStr = ""; saveFragment = true;
		}

		function makeHead(attribute, tabs, itemName)
		{
			var tmp = tabs + '<' + itemName;
			if (attribute) { if (gHorizontal) { return tmp; } else { return tmp + '\n'; } }
			return tmp + '>\n';
		}

		function makeItem(attribute, tabs, itemName, itemValue)
		{
			if (attribute)
			{
				var tmp = itemName + '="' + itemValue + '"';
				if (gHorizontal) { return ' ' + tmp; } else { return tabs + tmp + '\n'; }
			}
			return tabs + '<' + itemName + '>' + itemValue + '</' + itemName + '>\n';
		}

		function makeNeck(attribute, tabs)
		{
			if (attribute) { if (gHorizontal) { return '>\n'; } else { return tabs + '>\n'; } }
			return '';
		}

		function makeTail(attribute, tabs, itemName)
		{
			if (attribute) { if (gHorizontal) { return '/>\n'; } else { return tabs + '/>\n'; } }
			return tabs + '</' + itemName + '>\n';
		}
		
		function extraWidgetDef()
		{
			var objDef = [ ['author','author:','text',[''],'','The author of this widget.'],
						   ['company','company:','text',[''],'','The company of this widget.'],
						   ['copyright','copyright:','text',[''],'','The copyright notice for this widget.'],
						   ['id','id:','text',[''],'','The ID string for this widget.'],
						   ['image','image:','text',[''],'','Pathname  to an image for this widget.'],
						   ['name','name:','text',[''],'','The name of this widget.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 6 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Widget Definition', 'Save');
			
			var result = "";

			if (formResults !== null) {
				var author    = formResults[0];
				var company   = formResults[1];
				var copyright = formResults[2];
				var id        = formResults[3];
				var image     = formResults[4];
				var name      = formResults[5];

				if (author    !== "") { result += ' author="'    + author    + '"'; }
				if (company   !== "") { result += ' company="'   + company   + '"'; }
				if (copyright !== "") { result += ' copyright="' + copyright + '"'; }
				if (id        !== "") { result += ' id="'        + id        + '"'; }
				if (image     !== "") { result += ' image="'     + image     + '"'; }
				if (name      !== "") { result += ' name="'      + name      + '"'; }
			}
			
			for (i = 0; i < 6 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return result;
		}

		function widgetDef() {
		
			var objDef = [ ['version','version:','text',[''],'1.0','The version number of this widget.'],
						   ['minimumVersion','minimumVersion:','text',[''],'3.1','The minimum version of Konfabulator required to run this widget.'],
						   ['strictXML','strictXML:','popup',['false','true'],'false','Whether or not XML should be strictly checked.'],
						   ['debug','debug:','popup',['errors','on','off','verbose'],'errors','The debug mode for this widget.'],
						   ['defaultTracking','defaultTracking:','popup',['opacity','rectangle'],'opacity','The tracking attribute of this widget.'],
						   ['requiredPlatform','requiredPlatform:','popup',['any','macintosh','windows'],'any','The platform required to run this widget.'],
						   ['option1','Allow Custom Object Attributes','checkbox',[''],'0',''],
						   ['option2',"Don't Remember Window Position",'checkbox',[''],'0',''],
						   ['option3','Allow Arbitrary XML','checkbox',[''],'0',''] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 9 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Widget Definition', 'Save and Go On');

			if (formResults !== null) {
				var version   = formResults[0];
				var minVer    = formResults[1];
				var strictXML = formResults[2];
				var debug     = formResults[3];
				var defaultTracking  = formResults[4];
				var requiredPlatform = formResults[5];
				var option1 = formResults[6];
				var option2 = formResults[7];
				var option3 = formResults[8];
				
				var result = extraWidgetDef();

				widgetStr = '<?xml version="1.0" encoding="UTF-8"?>\n';
				if (strictXML == "true") { widgetStr += '<?konfabulator xml-strict="true"?>\n'; }
				widgetStr += '<widget version="' + version +  '" minimumVersion="' + minVer + '"' + result + '>\n';
				
				if (option1 !== "0") { widgetStr += '\t<option>allowCustomObjectAttributes</option>\n'; } 
				if (option2 !== "0") { widgetStr += '\t<option>dontRememberWindowPosition</option>\n'; } 
				if (option3 !== "0") { widgetStr += '\t<option>allowArbitraryXML</option>\n'; } 
				
				if (defaultTracking != 'opacity') { widgetStr += '\t<defaultTracking>' + defaultTracking + '</defaultTracking>\n'; }
				if (requiredPlatform != 'any') { widgetStr += '\t<requiredPlatform>' + requiredPlatform + '</requiredPlatform>\n'; }

				widgetStr += makeItem(false, '\t', 'debug', debug) + '\n';	// '\t<debug>' + debug + '</debug>\n\n';
				fragmentStr = widgetStr;
				displayFragment(fragmentStr, "widget", false);
			}
			
			for (i = 0; i < 9 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			if (widgetStr !== "") { widgetPref.opacity=63; }	// Dim the Widget Definition Button
		}

		function textShadowDef(extraTabs)
		{
			var objDef = [ ['shadowHOffset', 'hOffset:', 'text', [''],'1','The horizontal offset of the text shadow.'],
						   ['shadowVOffset', 'vOffset:', 'text', [''],'1','The vertical offset of text shadow.'],
						   ['shadowColor',   'color:','text',[''],'#000000','The color of the text shadow as an RGB triplet.'],
						   ['shadowOpacity', 'opacity:','text',[''],'128','The opacity of the text shadow.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 4 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var newStr    = "";
			
			var formResults = form(formfields, 'Text Shadow Definition', 'Save');

			if (formResults !== null) {
				var shadowHOffset = formResults[0];
				var shadowVOffset = formResults[1];
				var shadowColor   = formResults[2];
				var shadowOpacity = formResults[3];

				newStr += makeHead(gAttribute, extraTabs, 'shadow');
				newStr += makeItem(gAttribute, extraTabs + '\t', 'hOffset', shadowHOffset);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'vOffset', shadowVOffset);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'color',   shadowColor);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'opacity', shadowOpacity);
				newStr += makeTail(gAttribute, extraTabs, 'shadow');	
			}
			
			for (i = 0; i < 4 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return newStr;
		}

		function aboutTextDef(aboutTextType)
		{
			
			var objDef = [ ['font','font:','text',[''],'Courier','The name of the text font.'],
						   ['size','size:','text',[''],'12','The point size of the text font.'],
						   ['style','style:','text',[''],'','The style of the text font.'],
						   ['hOffset', 'hOffset:', 'text', [''],'0','The horizontal offset of this text.'],
						   ['vOffset', 'vOffset:', 'text', [''],'0','The vertical offset of this text.'],
						   ['color','color:','text',[''],'#ffffff','The color of the text as an RGB triplet.'],
						   ['enter','Define Text Shadow','checkbox',[''],'0','Check this box if you wish to define a text shadow.'],
						   ['data','data:','text',[''],'','The text of the about-text.'],
						   ['url','url:','text',[''],'','Optionally, the URL of a link for the about-text.'] ];

			var formfields = [];
			var i = 0;
			var aboutTextStr = "";
			var textShadowStr = "";
			var n = 7;
			var buttonText = 'Save';
			
			if (aboutTextType != 'About-Version') { n = 9; buttonText = 'Save and Go On'; }

			for (i = 0; i < n ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, aboutTextType + ' Definition', buttonText);

			if (formResults !== null) {
				var font    = formResults[0];
				var size    = formResults[1];
				var style   = formResults[2];
				var hOffset = formResults[3];
				var vOffset = formResults[4];
				var color   = formResults[5];
				var enter   = formResults[6];
				
				aboutTextStr  = makeHead(gAttribute, '\t\t', aboutTextType.toLowerCase());
				
				if (font    !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'font',    font);    }
				if (size    !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'size',    size);    }
				if (style   !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'style',   style);   }
				if (hOffset !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'hOffset', hOffset); }
				if (vOffset !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'vOffset', vOffset); }
				if (color   !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'color',   color);   }
				
				if (aboutTextType != 'About-Version')
				{
					var data = formResults[7];
					var url  = formResults[8];
					
					aboutTextStr += makeItem(gAttribute, '\t\t\t', 'data',    data);
					if (url !== "") { aboutTextStr += makeItem(gAttribute, '\t\t\t', 'url',    url); }
				}

				if (enter == "1")
				{
					textShadowStr = textShadowDef('\t\t\t');
					if (textShadowStr !== "")
					{ 
						aboutTextStr += makeNeck(gAttribute, '\t\t') + textShadowStr;
					}
				}
				
				aboutTextStr += makeTail(gAttribute && (textShadowStr === ""), '\t\t', aboutTextType.toLowerCase());
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return aboutTextStr;
		}
		
		function aboutDef(aboutSpec) {
		
			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			eprint("aboutSpec=" + aboutSpec);
			
			var widthSpec  = "";
			var heightSpec = "";
			var pathSpec   = "";
			
			if ( aboutSpec !== "")
			{
				var item = aboutSpec.split(",",3);
				widthSpec  = item[0];
				heightSpec = item[1];
				pathSpec   = item[2];
			}

			var objDef = [ ['aboutBox','about-image:','text',[''],'Resources/About.png','Pathname of this about-image.'],
						   ['aboutVersion','aboutVersion / aboutText','checkbox',[''],'0','Check this box if you wish to define an about-version block or about-text blocks for this about-box.'] ];
			
			var n = 1; if (aboutStr === "") { n = 2; }	// offer version/text definition on first about-box image.
			
			var formfields = [];
			var i = 0;

			for (i = 0; i < n ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			if (pathSpec !== "") { formfields[0].defaultValue = pathSpec; }

			var formResults = form(formfields, 'About-Box Definition', 'Save');

			if (formResults !== null) {
				var about = formResults[0];
				if (n == 2) { var aboutVersion = formResults[1]; }
				
				if (aboutStr === "") { aboutStr = '\t<about-box>\n'; }
				
				aboutStr += '\t\t<about-image>' + about + '</about-image>\n';
				
				if (aboutVersion == "1")
				{
					aboutStr += aboutTextDef('About-Version');
					
					var temp = aboutTextDef('About-Text');
					while (temp !== "") { aboutStr += temp; temp = aboutTextDef('About-Text'); }
				}

				fragmentStr = aboutStr;
				displayFragment(fragmentStr, "about", false);
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function timerDef() {
		
			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			var objDef = [ ['id','id:','text',[''],'','The ID string for this timer.'],
						   ['name','name:','text', [''],'','The name of this timer.'],
						   ['interval','interval:','text',[''],'60','The interval (in seconds) to be used with this timer.'],
						   ['ticking','ticking:','popup',['false','true'],'true','Whether on not the timer is ticking.'],
						   ['onTimerFired','onTimerFired:','text',[''],'','Enter a javascript statement.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 5 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Timer Definition', 'Save');

			if (formResults !== null) {
				var id           = formResults[0];
				var name         = formResults[1];
				var interval     = formResults[2];
				var ticking      = formResults[3];
				var onTimerFired = formResults[4];

				var newStr  = makeHead(gAttribute, '\t', 'timer');
					newStr += makeItem(gAttribute, '\t\t', 'id', id);
				    newStr += makeItem(gAttribute, '\t\t', 'name', name);
				    newStr += makeItem(gAttribute, '\t\t', 'interval', interval);
				    newStr += makeItem(gAttribute, '\t\t', 'ticking', ticking);
				    newStr += makeItem(gAttribute, '\t\t', 'onTimerFired', onTimerFired);
					newStr += makeTail(gAttribute, '\t', 'timer');
				
				fragmentStr = newStr;
				displayFragment(fragmentStr, "timer", true);
			}
			
			for (i = 0; i < 5 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function contextMenuItemDef(extraTabs)
		{
			var objDef = [ ['title','title:','text', [''],'','The title of this menu item.'],
						   ['onSelect','onSelect:','text',[''],'','Enter a javascript statement.'],
						   ['enabled','enabled:','popup',['false','true'],'true','Whether on not the menu item is enabled.'],
						   ['checked','checked:','popup',['false','true'],'false','Whether on not the menu item is checked.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 4 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var newStr = '';
			
			var formResults = form(formfields, 'Context Menu Item Definition', 'Save and Go On');

			if (formResults !== null) {
				var title = formResults[0];
				var onSelect = formResults[1];
				var enabled = formResults[2];
				var checked = formResults[3];

				newStr += makeHead(gAttribute, extraTabs, 'menuItem');
				newStr += makeItem(gAttribute, extraTabs + '\t', 'title', title);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'onSelect', onSelect);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'enabled', enabled);
				newStr += makeItem(gAttribute, extraTabs + '\t', 'checked', checked);
				newStr += makeTail(gAttribute, extraTabs, 'menuItem');
			}
			
			for (i = 0; i < 4 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return newStr;
		}

		function actionDef() {
		
			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }

			var objDef = [ ['trigger','trigger:','popup',['onGainFocus','onIdle', 'onKeyDown', 'onKeyUp',
														 'onKonsposeActivated','onKonsposeDeactivated','onLoad','onLoseFocus',
														 'onMouseDown', 'onMouseEnter', 'onMouseExit', 'onMouseUp',
														 'onPreferencesChanged',
														 'onRunCommandInBgComplete','onScreenChanged','onTellWidget','onTimer','onUnload',
														 'onWakeFromSleep','onWillChangePreferences','onYahooLoginChanged'],
							'onTimer','The event which triggers this action.'],
						   ['interval','interval:','text',[''],'60','The interval (in seconds) to be used with a timer action.'],
						   ['file','file:','text',[''],'','The file (if any) containing the javascript for this action.'],
						   ['enter','Enter Code','checkbox',[''],'0','Check this box if you wish to enter javascript code for this action.'] ];

			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 4 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Action Definition', 'Save');

			if (formResults !== null) {
				var trigger = formResults[0];
				var interval = formResults[1];
				var file = formResults[2];
				var enter = formResults[3];

				var newStr  = makeHead(true, '\t', 'action');
				    newStr += makeItem(true, '\t\t', 'trigger', trigger);
				
				if (trigger == 'onTimer') { newStr += makeItem(true, '\t\t', 'interval', interval); }

				if (file !== '') { newStr += makeItem(true, '\t\t', 'file', file); enter = '0'; }
				
				if (enter != "0")
				{
					newStr += makeNeck(true, '\t');
					gActionStr = newStr;
					code.data = '';
					buttonsEnabled = false;
					showActionText();
				}
				else 
				{
					newStr += makeTail(true, '\t', 'action');
					
					fragmentStr = newStr;
					displayFragment(fragmentStr, "action", true);
				}
			}

			for (i = 0; i < 4 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function entab(theStr)
		{
			if (theStr === "") { return ""; }

			if (theStr[theStr.length - 1] == '\n') { theStr = theStr.substring(0, theStr.length -1); }
			
			var line = theStr.split('\n');
			for (var i = 0; i < line.length; i += 1)
			{
				line[i] = '\t\t' + line[i];
			}
			return line.join('\n') + '\n';
		}

		function actionTextSave(saved)
		{
			if (saved) 
			{
				gActionStr += '\t<![CDATA[\n' + entab(code.data)  + '\t]]>\n';
			}
			gActionStr += makeTail(false, '\t', 'action');
			
			fragmentStr = gActionStr;
			displayFragment(fragmentStr, "action", true);

			hideActionText();
			buttonsEnabled = true;
		}

		function showActionText()
		{
			main_window.width = 750;
			
			if (monitor.opacity !== 0)
			{
				main_window.height = 568;
				code.vOffset = 288;
				buttons.vOffset = 507;
				cancel.vOffset = saveText.vOffset = 520;
			}
			else
			{
				main_window.height = 288;
				code.vOffset = 13;
				buttons.vOffset = 232;
				cancel.vOffset = saveText.vOffset = 245;
			}
			
			for (var i = 31; i < 256; i += 32)
			{
				code.opacity = code.bgOpacity = buttons.opacity = cancel.opacity = saveText.opacity = i;
				if (i < 255) { sleep(10); }
			}

			code.scrollbar = true;
			
			code.zOrder = 30;
			buttons.zOrder = 35;
			cancel.zOrder = 40;
			saveText.zOrder = 40;
		}

		function hideActionText()
		{
			code.scrollbar = false;
			
			code.zOrder = 0;
			buttons.zOrder = 0;
			cancel.zOrder = 0;
			saveText.zOrder = 0;

			for (var i = 224; i >= 0; i -= 32)
			{
				code.opacity = code.bgOpacity = buttons.opacity = cancel.opacity = saveText.opacity = i;
				if (i > 0) { sleep(10); }
			}
			
			if (monitor.opacity === 0)
			{
				main_window.width = 144;
				main_window.height = 288;
			}
		}

		function showDisplay()
		{
			main_window.width = 750;
			monitorCancel.opacity = 0;
			
			monitor.editable = false;
			monitorEdit.src="Resources/Pictures/Edit.png";
			editDisabled = true;

			for (var i = 31; i < 256; i += 32)
			{
				monitor.opacity = monitor.bgOpacity = monitorButtons.opacity = copy.opacity = monitorEdit.opacity = i;
				if (i < 255) { sleep(50); }
			}
			updateNow();
			
			monitor.scrollbar = true;
		}

		function hideDisplay()
		{
			monitor.scrollbar = false;
			
			monitor.editable = false;
			monitorEdit.src="Resources/Pictures/Edit.png";
			editDisabled = true;

			for (var i = 224; i >= 0; i -= 32)
			{
				monitor.opacity = monitor.bgOpacity = monitorButtons.opacity = copy.opacity = monitorEdit.opacity = monitorCancel.opacity = i;
				if (i > 0) { sleep(50); }
			}
			updateNow();

			if (code.opacity === 0) { main_window.width = 144; }
		}

		function moveActionText(up)
		{
			if (! up) { main_window.height = 568; }

			var done1, done2, done3, done4;
			
			if (up)
			{
				done1 = new MoveAnimation( code,     code.hOffset,      13, 1000, animator.kEaseOut );
				done2 = new MoveAnimation( buttons,  buttons.hOffset,  232, 1000, animator.kEaseOut );
				done3 = new MoveAnimation( cancel,   cancel.hOffset,   245, 1000, animator.kEaseOut );
				done4 = new MoveAnimation( saveText, saveText.hOffset, 245, 1000, animator.kEaseOut );
			}
			else
			{
				done1 = new MoveAnimation( code,     code.hOffset,     288, 1000, animator.kEaseOut );
				done2 = new MoveAnimation( buttons,  buttons.hOffset,  507, 1000, animator.kEaseOut );
				done3 = new MoveAnimation( cancel,   cancel.hOffset,   520, 1000, animator.kEaseOut );
				done4 = new MoveAnimation( saveText, saveText.hOffset, 520, 1000, animator.kEaseOut );
			}
			
			animator.runUntilDone( [done1, done2, done3, done4] );
			
			if (up) { main_window.height = 288; }
		}

		function setDisplay()
		{
			if (preferences.displayPref.value != "0")	// display required
			{
				if (monitor.opacity === 0)				// display not showing
				{
					if (code.opacity !== 0)				// but code window is showing
					{
						moveActionText(false);
						showDisplay();					// show display
					}
					else { showDisplay(); }				// just show display
				}
			}
			else										// display not required
			{
				if (monitor.opacity !== 0)				// display is showing
				{
					if (code.opacity !== 0)				// but code window is showing
					{
						hideDisplay();					// hide display
						moveActionText(true);
					}
					else { hideDisplay(); }				// just hide display
				}
			}
		}

		function hotkeyDef() {

			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			var objDef = [ ['id','id:','text',[''],'','The ID string for this hotkey.'],
						   ['name','name:','text',[''],'','The name of this hotkey.'],
						   ['key','key:','text',[''],'','The hotkey.'],
						   ['modifier','modifier:','text',[''],'command','The modifier key(s) for this hotkey.'],
						   ['onKeyDown','onKeyDown:','text',[''],'','The action to be taken onKeyDown.'],
						   ['onKeyUp','onKeyUp:','text',[''],'','The action to be taken onKeyUp.'] ];

			var formfields = [];
			var i = 0;

			for (i = 0; i < 6 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Hotkey Definition', 'Save');

			if (formResults !== null) {
				var id        = formResults[0];
				var name      = formResults[1];
				var key       = formResults[2];
				var modifier  = formResults[3];
				var onKeyDown = formResults[4];
				var onKeyUp   = formResults[5];

				var newStr  = makeHead(gAttribute, '\t', 'hotkey');
				    newStr += makeItem(gAttribute, '\t\t', 'id', id);
				    newStr += makeItem(gAttribute, '\t\t', 'key', key);
				    newStr += makeItem(gAttribute, '\t\t', 'modifier', modifier);
				    newStr += makeItem(gAttribute, '\t\t', 'onKeyDown', onKeyDown);
				    newStr += makeItem(gAttribute, '\t\t', 'onKeyUp', onKeyUp);
					newStr += makeTail(gAttribute, '\t', 'hotkey');
				
				fragmentStr = newStr;
				displayFragment(fragmentStr, "hotkey", true);
			}
			
			for (i = 0; i < 6 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function eventDef(objectType) {

			var objDef = [ ['onDragDrop','onDragDrop:','text',[''],'','Enter a javascript statement.'],
						   ['onDragEnter','onDragEnter:','text',[''],'',''],
						   ['onDragExit','onDragExit:','text',[''],'',''],
						   ['onKeyUp','onKeyUp:','text',[''],'',''],
						   ['onKeyDown','onKeyDown:','text',[''],'',''],
						   ['onKeyPress','onKeyPress:','text',[''],'',''],
						   ['onGainFocus','onGainFocus:','text',[''],'',''],
						   ['onLoseFocus','onLoseFocus:','text',[''],'',''],
						   ['onImageLoaded','onImageLoaded:','text',[''],'',''] ];

			var formfields = [];
			var eventStr = "";
			var i = 0;
			var n = 3;
			
			if (objectType == "Text Area") { n = 8; }

			for (i = 0; i < n ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[0][5];
			}
			
			if (objectType == "Image")
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[8][0];
				formfields[i].title = objDef[8][1];
				formfields[i].type = objDef[8][2];
				formfields[i].option = objDef[8][3];
				formfields[i].defaultValue = objDef[8][4];
				formfields[i].description = objDef[0][5];
				n = 4;
			}

			var formResults = form(formfields, objectType +' Event Definition', 'Save');

			if (formResults !== null) {
				var onDragDrop  = formResults[0];
				var onDragEnter = formResults[1];
				var onDragExit  = formResults[2];
				
				if (onDragDrop  !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onDragDrop',  onDragDrop);  }
				if (onDragEnter !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onDragEnter', onDragEnter); }
				if (onDragExit  !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onDragExit',  onDragExit);  }
				
				if (objectType == "Text Area")
				{
					var onKeyUp     = formResults[3];
					var onKeyDown   = formResults[4];
					var onKeyPress  = formResults[5];
					var onGainFocus = formResults[6];
					var onLoseFocus = formResults[7];

					if (onKeyUp     !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onKeyUp',     onKeyUp);     }
					if (onKeyDown   !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onKeyDown',   onKeyDown);   }
					if (onKeyPress  !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onKeyPress',  onKeyPress);  }
					if (onGainFocus !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onGainFocus', onGainFocus); }
					if (onLoseFocus !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onLoseFocus', onLoseFocus); }
				}
				
				if (objectType == "Image")
				{
					var onImageLoaded  = formResults[3];
					if (onImageLoaded  !== "") { eventStr += makeItem(gAttribute, extraTab + '\t\t', 'onImageLoaded', onImageLoaded); }
				}
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return eventStr;
		}

		function moreEventDef(objectType) {

			var objDef = [ ['onMouseDown','onMouseDown:','text',[''],'','Enter a javascript statement.'],
						   ['onMouseEnter','onMouseEnter:','text',[''],'',''],
						   ['onMouseExit','onMouseExit:','text',[''],'',''],
						   ['onMouseUp','onMouseUp:','text',[''],'',''],
						   ['onClick','onClick:','text',[''],'',''],
						   ['onMultiClick','onMultiClick:','text',[''],'',''],
						   ['onMouseDrag','onMouseDrag:','text',[''],'',''],
						   ['onMouseMove','onMouseMove:','text',[''],'',''],
						   ['onContextMenu','onContextMenu:','text',[''],'',''],
						   ['onMouseWheel','onMouseWheel:','text',[''],'',''] ];

			var formfields = [];
			var eventStr = "";
			var i = 0;
			var n = 8;

			for (i = 0; i < 8 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[0][5];
			}

			if (objectType != "Scroll Bar") {
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[0][5];
				i += 1;
				n += 1;
			}
			
			if (objectType == "Frame") {
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[0][5];
				i += 1;
				n += 1;
			}

			var formResults = form(formfields, objectType +' Event Definition', 'Save');

			if (formResults !== null) {
				var onMouseDown   = formResults[0];
				var onMouseEnter  = formResults[1];
				var onMouseExit   = formResults[2];
				var onMouseUp     = formResults[3];
				var onClick		  = formResults[4];
				var onMultiClick  = formResults[5];
				var onMouseDrag   = formResults[6];
				var onMouseMove   = formResults[7];

				if (onMouseDown   !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseDown',   onMouseDown);   }
				if (onMouseEnter  !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseEnter',  onMouseEnter);  }
				if (onMouseExit   !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseExit',   onMouseExit);   }
				if (onMouseUp     !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseUp',     onMouseUp);     }
				if (onClick       !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onClick',       onClick);       }
				if (onMultiClick  !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMultiClick',  onMultiClick);  }
				if (onMouseDrag   !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseDrag',   onMouseDrag);   }
				if (onMouseMove   !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseMove',   onMouseMove);   }

				if (objectType != "Scroll Bar") {
					var onContextMenu = formResults[8];
					if (onContextMenu !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onContextMenu', onContextMenu); }
				}

				if (objectType == "Frame") {
					var onMouseWheel = formResults[n-1];
					if (onMouseWheel !== "") { eventStr +=  makeItem(gAttribute, extraTab + '\t\t', 'onMouseWheel', onMouseWheel); }
				}
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return eventStr;
		}

		function windowEventDef() {

			var objDef = [ ['onContextMenu','onContextMenu:','text',[''],'','Enter a javascript statement.'],
						   ['onMultiClick','onMultiClick:','text',[''],'',''] ];

			var formfields = [];
			var eventStr = "";
			var i = 0;

			for (i = 0; i < 2 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[0][5];
			}

			var formResults = form(formfields, 'Window' + ' Event Definition', 'Save');

			if (formResults !== null) {
				var onContextMenu = formResults[0];
				var onMultiClick  = formResults[1];

				if (onContextMenu !== "") { eventStr +=  makeItem(false, '\t\t', 'onContextMenu', onContextMenu); }
				if (onMultiClick !== "")  { eventStr +=  makeItem(false, '\t\t', 'onMultiClick',  onMultiClick);  }
			}
			
			for (i = 0; i < 2 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return eventStr;
		}
		
		function extraImageDef(objectType,pathSpec) {

			var objDef = [ ['src','src:','text',[''],'Resources/Images/Image00.png','Pathname or URL of the image file.'],
						   ['loadingSrc','loadingSrc:','text',[''],'','Pathname of an image file to be used while loading a remote file.'],
						   ['missingSrc','missingSrc:','text',[''],'','Pathname of an image file to be used in place of a missing image.'],
						   ['useFileIcon','useFileIcon:','popup',['false','true'],'false',"Whether to use the file's icon."],
						   ['remoteAsync','remoteAsync:','popup',['false','true'],'false',"Whether to fetch a remote file asynchronously."],
						   ['hRegistrationPoint','hRegistrationPoint:','text',[''],'','The Horizontal Registration Point.'],
						   ['vRegistrationPoint','vRegistrationPoint:','text',[''],'','The Vertical Registration Point.'],
						   ['rotation','rotation:','text',[''],'','The angle of rotation of the image (in degrees).'],
						   ['tracking','tracking:','popup',['opacity','rectangle'],'opacity','The tracking mode for the image.'],
						   ['zOrder','zOrder:','text',[''],'','The zOrder of the image.'] ];
						   
			var formfields = [];
			var extraStr = "";
			var i = 0;

			for (i = 0; i < 10 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			if (pathSpec !== "") { formfields[0].defaultValue = pathSpec; }

			var formResults = form(formfields, objectType +' Definition', 'Go On');

			if (formResults !== null) {
				var src = formResults[0];
				var loadingSrc = formResults[1];
				var missingSrc = formResults[2];
				var useFileIcon = formResults[3];
				var remoteAsync = formResults[4];
				var hRegistrationPoint = formResults[5];
				var vRegistrationPoint = formResults[6];
				var rotation = formResults[7];
				var tracking = formResults[8];
				var zOrder = formResults[9];
				
				gPathName = src;	// nasty kludge to return image pathname to some callers 
				
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'src', src);

				if (loadingSrc !== "")    	   { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'loadingSrc',  loadingSrc);  }
				if (missingSrc !== "")    	   { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'missingSrc',  missingSrc);  }
				if (useFileIcon == "true")     { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'useFileIcon', useFileIcon); }
				if (remoteAsync == "true")     { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'remoteAsync', remoteAsync); }
				if (hRegistrationPoint !== "") { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'hRegistrationPoint', hRegistrationPoint); }
				if (vRegistrationPoint !== "") { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vRegistrationPoint', vRegistrationPoint); }				
				if (rotation !== "")           { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'rotation',    rotation); }
				if (tracking !== "opacity")    { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'tracking',    tracking); }
				if (zOrder !== "")             { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'zOrder',      zOrder);   }
			}

			for (i = 0; i < 10 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function moreImageDef(objectType,pathSpec) {

			var objDef = [ ['fillMode','fillMode:','popup',['stretch','tile'],'stretch',"Whether to use tiling."],
						   ['tileOrigin','tileOrigin:','popup',['topLeft','bottomLeft','topRight','bottomRight'],'topLeft',"The Tiling Origin."],
						   ['clipRect','clipRect:','text',[''],'','The clipping rectangle (x,y,width,height).'],
						   ['vAlign', 'vAlign:', 'popup', ['top','center','bottom'],'top','The  vertical alignment of this ' + objectType +'.'],
						   ['hslAdjustment','hslAdjustment:','text',[''],'','The HSL Adjustment of the image (h,s,l).'],
						   ['hslTinting','hslTinting:','text',[''],'','The HSL Tinting of the image (h,s,l).'],
						   ['colorize','colorize:','text',[''],'','The Colorize color of the image (#rrggbb).'] ];

			var formfields = [];
			var extraStr = "";
			var i = 0;

			for (i = 0; i < 7 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, objectType +' Definition', 'Save');

			if (formResults !== null) {
				var fillMode = formResults[0];
				var tileOrigin = formResults[1];
				var clipRect = formResults[2];
				var vAlign = formResults[3];
				var hslAdjustment = formResults[4];
				var hslTinting = formResults[5];
				var colorize = formResults[6];

				if (fillMode != "stretch")    { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'fillMode',   fillMode);   }
				if (fillMode != "stretch")    { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'tileOrigin', tileOrigin); }
				if (clipRect !== "")          { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'clipRect',   clipRect);   }
				
											    extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vAlign',     vAlign);
											  
				if (hslAdjustment !== "")      { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'hslAdjustment', hslAdjustment); }
				if (hslTinting !== "")         { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'hslTinting',    hslTinting);    }
				if (colorize !== "")           { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'colorize',      colorize);      }
			}

			for (i = 0; i < 7 ; i += 1)
			{
				delete formfields[i];  
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function canvasDef()
		{
			//beep(); alert('Sorry - not yet implemented.'); return;
		
			var newStr = basicDef("Canvas","","");
			if  (newStr !== "")
			{
				newStr  = makeHead(gAttribute, extraTab + '\t', 'canvas') + newStr;

				newStr += eventDef("Canvas");
				newStr += moreEventDef("Canvas");
						
				newStr += makeNeck(gAttribute, extraTab + '\t');
						
				newStr += contextStr;
				newStr += makeTail(false, extraTab + '\t', 'canvas');
						
				fragmentStr = newStr;

				if (windowDefOpen) { fType = 'window'; } else if (frameDefOpen)  { fType = 'frame';  } else { fType = 'canvas'; }
				displayFragment(fragmentStr, fType, true);
			}
		}

		function imageDef(imageSpec) {
		
			eprint("imageSpec=" + imageSpec);
			
			var widthSpec  = "";
			var heightSpec = "";
			var pathSpec   = "";
			var fType;
			
			if ( imageSpec !== "")
			{
				var item = imageSpec.split(",",3);
				widthSpec  = item[0];
				heightSpec = item[1];
				pathSpec   = item[2];
			}

			var newStr = basicDef("Image",widthSpec,heightSpec);
			if  (newStr !== "")
			{
				newStr  = makeHead(gAttribute, extraTab + '\t', 'image') + newStr;

				var extraStr = extraImageDef("Image",pathSpec);
				if (extraStr !== "")
				{
					newStr += extraStr;
					extraStr = moreImageDef("Image",pathSpec);
					if (extraStr !== "")
					{
						newStr += extraStr;
						newStr += eventDef("Image");
						newStr += moreEventDef("Image");
						
						newStr += makeNeck(gAttribute, extraTab + '\t');
						
						newStr += contextStr;
						newStr += makeTail(false, extraTab + '\t', 'image');
						
						fragmentStr = newStr;

						if (windowDefOpen) { fType = 'window'; } else if (frameDefOpen)  { fType = 'frame';  } else { fType = 'image'; }
						displayFragment(fragmentStr, fType, true);

						if ((imageSpec === "") && (preferences.makeGcImagesPref.value != "0"))
						{
							var xtype = xtn(gPathName);
							
							if (xtype == '.png')
							{
								makeImage(gPathName, "PNG", gWidth, gHeight);
							}
							else if (xtype == '.jpg')
							{
								makeImage(gPathName, "JPEG", gWidth, gHeight);
							}
							else if (xtype == '.gif')
							{
								makeImage(gPathName, "GIF", gWidth, gHeight);
							}
							else { makeImage(gPathName, "PNG", gWidth, gHeight); }
						}
					}
				}
			}
		}

		function prefGroupDef() {

			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			var objDef = [ ['name','name:','text', [''],'','The name of this preference group.'],
						   ['title','title:','text', [''],'','The title of this preference group.'],
						   ['order','order:','text',[''],'','The order of this preference group.'],
					   	   ['icon','icon:','text',[''],'','Pathname of the icon for this preference group.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 4 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Preference Group Definition', 'Save');

			if (formResults !== null) {
				var name  = formResults[0];
				var title = formResults[1];
				var order = formResults[2];
				var icon  = formResults[3];

				var newStr  = makeHead(gAttribute, '\t', 'preferenceGroup');
				    newStr += makeItem(gAttribute, '\t\t', 'name', name);
				    newStr += makeItem(gAttribute, '\t\t', 'title', title);
				    newStr += makeItem(gAttribute, '\t\t', 'order', order);
    				if (icon !== "") { newStr += makeItem(gAttribute, '\t\t', 'icon', icon); }					
					newStr += makeTail(gAttribute, '\t', 'preferenceGroup');

				fragmentStr = newStr;
				displayFragment(fragmentStr, 'prefGroup', true);
			}
			
			for (i = 0; i < 4 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function popupPrefDef() {
			var formfields = [];
			var result = false;
			var i = 0;
			
			for (i = 0; i < 5; i += 1)
			{
				formfields[2*i] = new FormField();
				formfields[2*i].name = 'option'+ (2*i);
				formfields[2*i].title = 'Option:';
				formfields[2*i].type = 'text';
				formfields[2*i].defaultValue = '';
				formfields[2*i].description = '';
				
				formfields[2*i+1] = new FormField();
				formfields[2*i+1].name = 'option'+ (2*i+1);
				formfields[2*i+1].title = 'OptionValue:';
				formfields[2*i+1].type = 'text';
				formfields[2*i+1].defaultValue = '';
				formfields[2*i+1].description = '';
			}
			
			formfields[1].description = 'You need not fill in any optionValues, but, if you do, you must fill in an optionValue for each option.';
			formfields[9].description = 'Press Save to save these options. Press cancel to exit.';
			
			var formResults = form(formfields, 'Popup Preference Options', 'Save');

			if (formResults !== null) {
				var optionStr = "";
				var option = "";
				var optionValue = "";
				for (i = 0; i < 5; i += 1) {
					option = formResults[2*i];
					optionValue = formResults[2*i+1];
					if (option !== "") {
						optionStr += makeItem(false, '\t\t', 'option', option);
						if (optionValue !== "") {
							optionStr += makeItem(false, '\t\t', 'optionValue', optionValue);
						}
					}
				}

				prefStr += optionStr;
				result = true;
			}
			
			for (i = 0; i < 10; i += 1) {
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return 	result;
		}

		function selectorPrefDef() {

			var objDef = [ ['style','style:','popup',['open','save'],'open','The style of this selector.'],
						   ['directory','directory:','text',[''],'','The directory of this selector.'],
						   ['kind','kind:','popup',['files','folders','both'],'both','The kind of this selector.'] ];
		
			var formfields = [];
			var result = false;
			var i = 0;
			var j;
			
			for (i = 0; i < 3 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}


			for (j = i; j < 10; j += 1) {
				formfields[j] = new FormField();
				formfields[j].name = 'extension' + (j-i);
				formfields[j].title = 'Extension' + (j-i) + ':';
				formfields[j].type = 'text';
				formfields[j].defaultValue = '';
				formfields[j].description = 'Extension' + (j-i) + ' of this selector.';
			}

			var formResults = form(formfields, 'Selector Preferences', 'Save');

			if (formResults !== null) {
				var style = formResults[0];
				var directory = formResults[1];
				var kind = formResults[2];
				var selector = "";
				var selectorStr = "";
				
				if (style !== "")     {	selectorStr += makeItem(gAttribute, '\t\t', 'style', style); }
				if (directory !== "") { selectorStr += makeItem(gAttribute, '\t\t', 'directory', directory); }
				if (kind !== "")      { selectorStr += makeItem(gAttribute, '\t\t', 'kind', kind); }
				
				selectorStr += makeNeck(gAttribute, '\t');
				
				for (j = i; j < 10; j += 1) {
					extension = formResults[j];
					if (extension !== "") { selectorStr += makeItem(false, '\t\t', 'extension', extension); }
				}

				prefStr += selectorStr;
				result = true;
			}
			
			for (i = 0; i < 10; i += 1) {
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return result;
		}
		
		function sliderPrefDef() {

			var objDef = [ ['minLength','minLength:','text',[''],'0','The Minimum Length of this slider.'],
						   ['maxLength','maxLength:','text',[''],'100','The Maximum Length of this slider.'],
						   ['ticks','ticks:','text',[''],'11','The number of ticks on this slider.'] ];
		
			var formfields = [];
			var result = false;
			var i = 0;
			
			for (i = 0; i < 3 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			for (var j = i; j < 10; j += 1) {
				formfields[j] = new FormField();
				formfields[j].name = 'tickLabel' + (j-i);
				formfields[j].title = 'TickLabel' + (j-i) + ':';
				formfields[j].type = 'text';
				formfields[j].defaultValue = '';
				formfields[j].description = 'TickLabel' + (j-i) + ' of this slider.';
			}

			var formResults = form(formfields, 'Slider Preferences', 'Save');

			if (formResults !== null) {
				var minLength = formResults[0];
				var maxLength = formResults[1];
				var ticks = formResults[2];
				var tickLabel = "";
				var sliderStr = "";
				
				if (minLength !== "") { sliderStr += makeItem(gAttribute, '\t\t', 'minLength', minLength); }
				if (maxLength !== "") { sliderStr += makeItem(gAttribute, '\t\t', 'maxLength', maxLength); }
				if (ticks !== "")     { sliderStr += makeItem(gAttribute, '\t\t', 'ticks',     ticks);     }

				sliderStr += makeNeck(gAttribute, '\t');

				for (j = i; j < 10; j += 1) {
					tickLabel = formResults[j];
					if (tickLabel !== "") { sliderStr += makeItem(false, '\t\t', 'tickLabel', tickLabel); }
				}

				prefStr += sliderStr;
				result = true;
			}
			
			for (i = 0; i < 10; i += 1) {
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return result;
		}
		
		function prefDef() {

			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			var objDef = [ ['title','title:','text', [''],'','The title of this preference.'],
						   ['id','id:','text',[''],'','The ID string for this preference.'],
						   ['name', 'name:', 'text', [''],'','The name of this preference.'],
						   ['type', 'type:', 'popup',['checkbox','color','font','hotkey','popup','selector','slider','text'],'checkbox','The type of this preference.'],
						   ['defaultValue','defaultValue:','text', [''],'','The Default Value  of this preference.'],
						   ['hidden','hidden:','popup', ['false','true'],'false','Whether or not this preference is hidden.'],
						   ['notSaved','notSaved:','popup', ['false','true'],'false','Whether or not this preference is not saved.'],
						   ['description','description:','text', [''],'','The textual description of this preference.'],
						   ['group','group:','text', [''],'','The group in which this preference is to be placed.'],
						   ['secure','secure:','popup', ['false','true'],'false','Whether or not this preference is to be secure.'] ];
						   
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 10; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
	
			var formResults = form(formfields, 'Preference Definition', 'Save or Go On');

			if (formResults !== null) {
				var title        = formResults[0];
				var id           = formResults[1];
				var name         = formResults[2];
				var type         = formResults[3];
				var defaultValue = formResults[4];
				var hidden       = formResults[5];
				var notSaved     = formResults[6];
				var description  = formResults[7];
				var group        = formResults[8];
				var secure       = formResults[9];
				
				var result = true;
				var res    = true;
				
				saveStr = prefStr;
				
				prefStr  = makeHead(gAttribute, '\t', 'preference');
				prefStr += makeItem(gAttribute, '\t\t', 'title', title);
				prefStr += makeItem(gAttribute, '\t\t', 'id',   id);
				prefStr += makeItem(gAttribute, '\t\t', 'name', name);
				prefStr += makeItem(gAttribute, '\t\t', 'type', type);

				if (hidden == "true")   { prefStr += makeItem(gAttribute, '\t\t', 'hidden',      hidden); }		
				if (notSaved == "true") { prefStr += makeItem(gAttribute, '\t\t', 'notSaved',    notSaved); }	
				if (description !== "") { prefStr += makeItem(gAttribute, '\t\t', 'description', description); }	
				if (group !== "")       { prefStr += makeItem(gAttribute, '\t\t', 'group',       group); }	
				if (secure == "true")   { prefStr += makeItem(gAttribute, '\t\t', 'secure',      secure); }	

				if (defaultValue !== "") { prefStr += makeItem(gAttribute, '\t\t', 'defaultValue', defaultValue); }	

				if (type == 'popup')
				{
					prefStr += makeNeck(gAttribute, '\t');
					result = popupPrefDef();
					if (result)
					{
						while (res) { res = popupPrefDef(); }
					}
				}
				else if (type == 'selector') { result = selectorPrefDef(); }
				else if (type == 'slider')   { result = sliderPrefDef(); }
				
				
				if ((type == 'popup') || (type == 'selector') || (type == 'slider'))
				{
					prefStr += makeTail(false, '\t', 'preference');
				}
				else { prefStr += makeTail(gAttribute, '\t', 'preference'); }
				
				prefStr += '\n';
				
				fragmentStr = prefStr;
				
				prefStr = saveStr;

				if (result)
				{
					displayFragment(fragmentStr, 'pref', true);
				}
			}

			for (i = 0; i < 10 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}

		function extraTextDef(objectType) {
		
			var objDef = [ ['color','color:','text',[''],'#000000','The color of the text as an RGB triplet.'],
						   ['bgColor','bgColor:','text',[''],'#FFFFFF','The background color as an RGB triplet.'],
						   ['bgOpacity','bgOpacity:','text',[''],'255',''],
						   ['data','data:','text',[''],'','The text.'],
						   ['font','font:','text',[''],'','The name of the text font.'],
						   ['size','size:','text',[''],'12','The point size of the text font.'],
						   ['style','style:','text',[''],'','The style of the text font.'],
						   ['zOrder','zOrder:','text',[''],'','The zOrder of the text.'],
						   ['enter','Define Text Shadow','checkbox',[''],'0','Check this box if you wish to define a text shadow.'],
						   ['anchorStyle','anchorStyle:','popup',['baseline','topLeft'],'baseline','Where the hOffset points.'],
						   ['scrolling','scrolling:','popup',['off','left','right','autoLeft','autoRight'],'off','Whether and how the text should scroll.'],
						   ['truncation','truncation:','popup',['none','center','end'],'none','Whether and how the text should be truncated.'],
						   ['wrap','wrap:','popup',['false','true'],'false','Whether text should wrap.'] ];
						   
			var formfields = [];
			var extraStr = "";
			    shadowStr = "";	// used as a global output from this function
			var i = 0;
			var n = 8;
			var button = 'Go On';
			
			if (objectType == "Text") { n = 13; button = 'Save'; }

			for (i = 0; i < n ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, objectType +' Definition', button);

			if (formResults !== null) {
				var color = formResults[0];
				var bgColor = formResults[1];
				var bgOpacity = formResults[2];
				var data = formResults[3];
				var font = formResults[4];
				
				var size = formResults[5];
				var style = formResults[6];
				var zOrder = formResults[7];
				
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'color', color);
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'bgColor', bgColor);
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'bgOpacity', bgOpacity);
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'data', data);	
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'font', font);
				extraStr += makeItem(gAttribute, extraTab + '\t\t', 'size', size);
				
				if (style !== "")  { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'style',  style);  }
				if (zOrder !== "") { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'zOrder', zOrder); }

				if (objectType == "Text")
				{
					var enter       = formResults[8];
					var anchorStyle = formResults[9];
					var scrolling   = formResults[10];
					var truncation  = formResults[11];
					var wrap        = formResults[12];
 
					if (enter == "1") { shadowStr = textShadowDef(extraTab + '\t\t'); }
					
					if (anchorStyle  != "baseline")  { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'anchorStyle',  anchorStyle);  }
					if (scrolling    != "off")       { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'scrolling',    scrolling);  }
					if (truncation   != "none")      { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'truncation',   truncation); }
					if (wrap         != "false")     { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'wrap',         wrap);  }
				}
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function moreTextDef(objectType) {
		
			var objDef = [ ['columns','columns:','text',[''],'','The number of columns of text.'],
						   ['lines','lines:','text',[''],'','The number of lines(rows) of text.'],
						   ['editable','editable:','popup',['false','true'],'true',''],
						   ['scrollbar','scrollbar:','popup',['false','true'],'true',''],
						   ['thumbColor','thumbColor:','text',[''],'','The scrollbar thumb color as an RGB triplet.'],
						   ['spellcheck','spellcheck:','popup',['false','true'],'true',''],
						   ['vAlign', 'vAlign:', 'popup', ['top','center','bottom'],'top','The  vertical alignment of this ' + objectType +'.'],
						   ['secure', 'secure:', 'popup', ['false','true'],'false','Whether this ' + objectType +' is to be scrambled.'] ];
						   
						  
			var formfields = [];
			var extraStr = "";
			var i = 0;

			for (i = 0; i < 8 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, objectType +' Definition', 'Save');

			if (formResults !== null) {
				var columns    = formResults[0];
				var lines      = formResults[1];
				var editable   = formResults[2];
				var scrollbar  = formResults[3];
				var thumbColor = formResults[4];
				var spellcheck = formResults[5];
				var vAlign     = formResults[6];
				var secure     = formResults[7];
				
				if (columns    !== "")       { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'columns',    columns);    }
				if (lines      !== "")       { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'lines',      lines);      }
				if (editable    == "false")  { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'editable',   editable);   }
				if (scrollbar   == "false")  { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'scrollbar',  scrollbar);  }
				if (thumbColor !== "")       { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'thumbColor', thumbColor); }
				if (spellcheck  == "false")  { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'spellcheck', spellcheck); }
				if (vAlign     != 'top')	 { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vAlign',     vAlign);     }
				if (secure      == "true")   { extraStr += makeItem(gAttribute, extraTab + '\t\t', 'secure',     secure);     }
			}
			
			for (i = 0; i < 8 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function extraFrameDef() {

			var objDef = [ ['zOrder','zOrder:','text',[''],'','The zOrder of this frame.'],
						   ['vAlign', 'vAlign:', 'popup', ['top','center','bottom'],'top','The  vertical alignment of this frame.'],
						   ['hLineSize','hLineSize:','text',[''],'','The horizontal scrolling increment or decrement.'],
						   ['vLineSize','vLineSize:','text',[''],'','The vertical scrolling increment or decrement.'],
						   ['scrollX','scrollX:','text',[''],'','The horizontal scrolling offset.'],
						   ['scrollY','scrollY:','text',[''],'','The vertical scrolling offset.'],
						   ['hScrollBar','hScrollBar:','text',[''],'','The name of the horizontal scroll bar for this frame.'],
						   ['vScrollBar','vScrollBar:','text',[''],'','The name of the vertical scroll bar for this frame.'] ];
						   
			var formfields = [];
			var extraStr = "";
			var i = 0;

			for (i = 0; i < 8 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Frame Definition', 'Save');

			if (formResults !== null) {
				var zOrder = formResults[0];
				var vAlign = formResults[1];
				var hLineSize = formResults[2];
				var vLineSize = formResults[3];
				var scrollX = formResults[4];
				var scrollY = formResults[5];
				var hScrollBar = formResults[6];
				var vScrollBar = formResults[7];
				
				if (zOrder !== "")		{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'zOrder', zOrder);  }
				
										  extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vAlign', vAlign);
										  
				if (hLineSize !== "")	{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'hLineSize',  hLineSize);  }
				if (vLineSize !== "")	{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vLineSize',  vLineSize);  }
				if (scrollX !== "")		{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'scrollX',    scrollX);    }
				if (scrollY !== "")		{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'scrollY',    scrollY);    }				
				if (hScrollBar !== "")	{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'hScrollBar', hScrollBar); }
				if (vScrollBar !== "")	{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vScrollBar', vScrollBar); }
			}

			for (i = 0; i < 8 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function windowDef(sem)
		{
			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
				
			if (windowDefOpen)	// close current window
			{
				extraTab = "";
				windowDefOpen = false;
				
				var finishStr = makeTail(false, '\t', 'window');
				
				fragmentStr = finishStr;
				displayFragment(fragmentStr, 'window', true);

				windowPref.tooltip = "Click to start a window definition. Alt-click to start a frame definition.";
				return;
			}
			
			var newStr = basicWindowDef();
			if (newStr !== "")
			{
				var extraStr = extraWindowDef();
				if (extraStr !== "")
				{
					newStr += extraStr;
					newStr += contextStr;
					newStr += windowEventDef();
					newStr += '\n';
					
					fragmentStr = newStr;
					displayFragment(fragmentStr, 'window', true);

					windowPref.tooltip = "Click to finish the current window definition. Alt-click to start a frame definition.";
					extraTab = "\t";
					windowDefOpen = true;
				}
			}
		}

		function frameDef(sem)	// option or alt must be down to get here
		{
			var fType;
			
			if ((!frameDefOpen) && shiftKeyDown(sem)) { beep(); alert("Sorry - there is no frame definition in progress."); return; }
			if (shiftKeyDown(sem))	// close current frame
			{
				extraTab = extraTab.substring(1);
				var finishStr = makeTail(false, extraTab + '\t', 'frame') + '\n';

				fragmentStr = finishStr;
				
				if (windowDefOpen) { fType = 'window'; } else { fType = 'frame'; }
				displayFragment(fragmentStr, fType, true);

				frameDefOpen -= 1;

				if (frameDefOpen)
				{
					var tooltip  = "Shift+alt-click to finish the current frame definition. Alt-click to start a nested frame definition.";
					if (frameDefOpen == 1) { tooltip += "\n\nThere is currently an open frame definition."; }
					else { tooltip += "\n\nThere are currently " +  frameDefOpen + " open frame definitions."; }
					windowPref.tooltip = tooltip;
				}
				else
				{
					if (windowDefOpen)
					{
						windowPref.tooltip = "Click to finish the current window definition. Alt-click to start a frame definition.";
					}
					else
					{
						windowPref.tooltip = "Click to start a window definition. Alt-click to start a frame definition.";
					}
				}
				return;
			}

			var newStr = basicDef("Frame","","");
			if (newStr !== "")
			{
				var extraStr = extraFrameDef();
				if (extraStr !== "")
				{
					newStr  = makeHead(gAttribute, extraTab + '\t', 'frame') + newStr;
					newStr += extraStr;
					newStr += eventDef("Frame");
					newStr += moreEventDef("Frame");
					
					newStr += makeNeck(gAttribute, extraTab + '\t');
					
					newStr += contextStr;
					
					fragmentStr = newStr;
					
					if (windowDefOpen) { fType = 'window'; } else { fType = 'frame'; }
					displayFragment(fragmentStr, fType, true);

					frameDefOpen += 1;
					extraTab += "\t";
				
					tooltip  = "Shift+alt-click to finish the current frame definition. Alt-click to start a nested frame definition.";
					if (frameDefOpen == 1) { tooltip += "\n\nThere is currently an open frame definition."; }
					else { tooltip += "\n\nThere are currently " +  frameDefOpen + " open frame definitions."; }
					windowPref.tooltip = tooltip;
				}
			}
		}

		function textDef() {
			var fType;
			
			var newStr = basicDef("Text","","");
			if  (newStr !== "")
			{
				newStr  = makeHead(gAttribute, extraTab + '\t', 'text') + newStr;
				var extraStr = extraTextDef("Text");
				if (extraStr !== "")
				{
					newStr += extraStr;
					newStr += eventDef("Text");
					newStr += moreEventDef("Text");
					
					newStr += makeNeck(gAttribute, extraTab + '\t');
					
					newStr += contextStr;
					newstr += shadowStr;
					newStr += makeTail(false, extraTab + '\t', 'text') + '\n';
					
					fragmentStr = newStr;
					
					if (windowDefOpen) { fType = 'window'; } else if (frameDefOpen)  { fType = 'frame';  } else { fType = 'text'; }
					displayFragment(fragmentStr, fType, true);
				}
			}
		}

		function textAreaDef() {
			var fType;
			
			var newStr = basicDef("Text Area","","");
			if  (newStr !== "")
			{
				newStr  = makeHead(gAttribute, extraTab + '\t', 'textarea') + newStr;
				var extraStr = extraTextDef("Text Area");
				if (extraStr !== "")
				{
					newStr += extraStr;
					extraStr = moreTextDef("Text Area");
					if (extraStr !== "")
					{
						newStr += extraStr;
						newStr += eventDef("Text Area");
						newStr += moreEventDef("Text Area");
						
						newStr += makeNeck(gAttribute, extraTab + '\t');
						
						newStr += contextStr;

						newStr += makeTail(false, extraTab + '\t', 'textarea') + '\n';
						
						fragmentStr = newStr;
					
						if (windowDefOpen) { fType = 'window'; } else if (frameDefOpen)  { fType = 'frame';  } else { fType = 'textArea'; }
						displayFragment(fragmentStr, fType, true);
					}
				}
			}
		}

		function extraScrollBarDef()
		{
			var objDef = [ ['zOrder','zOrder:','text',[''],'','The zOrder of this scrollbar.'],
						   ['vAlign', 'vAlign:', 'popup', ['top','center','bottom'],'top','The  vertical alignment of this scrollbar.'],
						   ['max','max:','text',[''],'','The maximum value of this scrollbar.'],
						   ['min','min:','text',[''],'','The minimum value of this scrollbar.'],
						   ['orientation','orientation:','popup',['horizontal','vertical'],'vertical','The orientation of this scrollbar.'],
						   ['pageSize','pageSize:','text',[''],'','The page size of this scrollbar.'],
						   ['thumbColor','thumbColor:','color',[''],'#808080','The thumb color of this scroll bar.'],
						   ['value','value:','text',[''],'','The value of the scrollbar.'],
						   ['autoHide','autoHide:','popup',['false','true'],'false','The name of the vertical scroll bar for this frame.'],
						   ['onValueChanged','onValueChanged:','text',[''],'','Enter a javascript statement.'] ];
						   
			var formfields = [];
			var extraStr = "";
			var i = 0;

			for (i = 0; i < 10 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Scroll Bar Definition', 'Save');

			if (formResults !== null) {
				var zOrder = formResults[0];
				var vAlign = formResults[1];
				var max = formResults[2];
				var min = formResults[3];
				var orientation = formResults[4];
				var pageSize = formResults[5];
				var thumbColor = formResults[6];
				var value = formResults[7];
				var autoHide = formResults[8];
				var onValueChanged = formResults[9];

				if (zOrder !== "")				{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'zOrder', zOrder);  }
				
										 		  extraStr += makeItem(gAttribute, extraTab + '\t\t', 'vAlign', vAlign);
										 		  
				if (max !== "")					{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'max', max); }
				if (min !== "")					{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'min', min); }
				if (orientation != "vertical")	{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'orientation', orientation); }
				if (pageSize !== "")			{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'pageSize',    pageSize);    }
				
				 								  extraStr += makeItem(gAttribute, extraTab + '\t\t', 'thumbColor', thumbColor);
				 								  
				if (value !== "")				{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'value',          value);          }
				if (autoHide != "false")		{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'autoHide',       autoHide);       }
				if (onValueChanged !== "")		{ extraStr += makeItem(gAttribute, extraTab + '\t\t', 'onValueChanged', onValueChanged); }
			}

			for (i = 0; i < 10 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return extraStr;
		}

		function scrollBarDef()
		{
			var fType;
			
			var newStr = basicDef("Scroll Bar","","");
			if  (newStr !== "")
			{
				newStr  = makeHead(gAttribute, extraTab + '\t', 'scrollbar')  + newStr;
				var extraStr = extraScrollBarDef();
				if (extraStr !== "")
				{
					newStr += extraStr;
					newStr += makeTail(gAttribute, extraTab + '\t', 'scrollbar') + '\n';
					
					fragmentStr = newStr;
					
					if (windowDefOpen) { fType = 'window'; } else if (frameDefOpen)  { fType = 'frame';  } else { fType = 'scrollBar'; }
					displayFragment(fragmentStr, fType, true);
				}
			}
		}

		function settingsDef() {
		
			var objDef = [ ['debug','debug:','popup',['off','on','verbose'],'off','The debug setting of this widget.'],
						   ['defaultTracking','defaultTracking:','popup',['opacity','rectangle'],'opacity','The tracking attribute of this widget.'],
						   ['allowCustomObjectAttributes','allowCustomObjectAttributes','popup',['false','true'],'false',''],
						   ['dontRememberWindowPosition',"dontRememberWindowPosition",'popup',['false','true'],'false',''],
						   ['defaultAntiAlias','defaultAntiAlias','popup',['smooth','system'],'smooth','Windows only.'] ];
		
			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 5 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Settings Definition', 'Save');

			if (formResults !== null) {
				var debug            = formResults[0];
				var defaultTracking  = formResults[1];
				var allowCustomObjectAttributes = formResults[2];
				var dontRememberWindowPosition  = formResults[3];
				var defaultAntiAlias = formResults[4];
				
				settingsStr  = makeHead(false, '\t', 'settings');
				
				settingsStr += makeHead(gAttribute, '\t\t', 'setting');
				settingsStr += makeItem(gAttribute, '\t\t\t', 'name', 'debug');
				settingsStr += makeItem(gAttribute, '\t\t\t', 'value', debug);
				settingsStr += makeTail(gAttribute, '\t\t', 'setting');

				if (defaultTracking == 'rectangle')
				{
					settingsStr += makeHead(gAttribute, '\t\t', 'setting');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'name', 'defaultTracking');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'value', defaultTracking);
					settingsStr += makeTail(gAttribute, '\t\t', 'setting');
				}

				if (allowCustomObjectAttributes == 'true')
				{
					settingsStr += makeHead(gAttribute, '\t\t', 'setting');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'name', 'allowCustomObjectAttributes');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'value', allowCustomObjectAttributes);
					settingsStr += makeTail(gAttribute, '\t\t', 'setting');
				}
				
				if (dontRememberWindowPosition == 'true')
				{
					settingsStr += makeHead(gAttribute, '\t\t', 'setting');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'name', 'dontRememberWindowPosition');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'value', dontRememberWindowPosition);
					settingsStr += makeTail(gAttribute, '\t\t', 'setting');
				}
				
				if (defaultAntiAlias == 'system')
				{
					settingsStr += makeHead(gAttribute, '\t\t', 'setting');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'name', 'defaultAntiAlias');
					settingsStr += makeItem(gAttribute, '\t\t\t', 'value', defaultAntiAlias);
					settingsStr += makeTail(gAttribute, '\t\t', 'setting');
				}

				settingsStr += makeTail(false, '\t', 'settings');
				
				fragmentStr = settingsStr;
				displayFragment(fragmentStr, "settings", false);
			}
			
			for (i = 0; i < 5 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
		}
		
		function basicDef(objectType,widthSpec,heightSpec) {	// Canvas, Frame, Image, Text, TextArea, ScrollBar but NOT Window
		
			var objectLcType = objectType.toLowerCase();
			
			var objDef = [ ['id','id:','text', [''],'','The id of this ' + objectLcType +'.'],
						   ['name','name:','text', [''],'','The name of this ' + objectLcType +'.'],
						   ['width', 'width:', 'text', [''],'200','The horizontal width of this ' + objectLcType +'.'],
						   ['height', 'height:', 'text', [''],'200','The vertical height of this ' + objectLcType +'.'],
						   ['hAlign', 'hAlign:', 'popup', ['left','center','right'],'left','The  horizontal alignment of this ' + objectLcType +'.'],
						   ['hOffset', 'hOffset:', 'text', [''],'0','The horizontal offset of this ' + objectLcType +'.'],
						   ['vOffset', 'vOffset:', 'text', [''],'0','The vertical offset of this ' + objectLcType +'.'],
						   ['opacity', 'opacity:', 'text', [''],'255','The opacity of this ' + objectLcType +'.'],
						   ['style', 'style:', 'text', [''],'','The style of this ' + objectLcType +'.'],
						   ['visible', 'visible:', 'popup', ['false','true'],'true','The visibility of this ' + objectLcType +'.'],
						   ['tooltip', 'tooltip:', 'text', [''],'','A tooltip for this ' + objectLcType +'.'],
						   ['window', 'window:', 'text', [''],'','The window to which this ' + objectLcType + ' belongs.'],
						   ['enter','Define Menu Items','checkbox',[''],'0','Check this box if you wish to define context menu items.'] ];

			var formfields = [];
			var basicStr   = "";
			    contextStr = "";	// used as a global output from this function

			var i = 0;

			for (i = 0; i < 10 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			if (objectType == "Image")
			{
				if (widthSpec  !== "") { formfields[1].defaultValue = widthSpec; }
				if (heightSpec !== "") { formfields[2].defaultValue = heightSpec; }
			}
			
			if (true)	// ((objectType != "Frame") && (objectType != "Scroll Bar"))	// tooltip
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
				i += 1;
			}
			
			if (!windowDefOpen)	// don't show the window tag if this definition is nested inside a window definition
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[11][0];
				formfields[i].title = objDef[11][1];
				formfields[i].type = objDef[11][2];
				formfields[i].option = objDef[11][3];
				formfields[i].defaultValue = objDef[11][4];
				formfields[i].description = objDef[11][5];
				i += 1;
			}

			if (objectType != "Scroll Bar")
			{
				formfields[i] = new FormField();	// Define Menu Items checkbox
				formfields[i].name = objDef[12][0];
				formfields[i].title = objDef[12][1];
				formfields[i].type = objDef[12][2];
				formfields[i].option = objDef[12][3];
				formfields[i].defaultValue = objDef[12][4];
				formfields[i].description = objDef[12][5];
				i += 1;
			}

			var n = i;

			var formResults = form(formfields, objectType +' Definition', 'Go On');

			if (formResults !== null) {
				var id      = formResults[0];
				var name    = formResults[1];
				var width   = formResults[2];
				var height  = formResults[3];
				var hAlign  = formResults[4];
				var hOffset = formResults[5];
				var vOffset = formResults[6];
				var opacity = formResults[7];
				var style   = formResults[8];
				var visible = formResults[9];
				
				gWidth = width;			// nasty kludge to return image size to some callers
				gHeight = height;

				if (id !== "") { basicStr += makeItem(gAttribute, extraTab + '\t\t', 'id',      id); }
				
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'name',    name);
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'width',   width);
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'height',  height);
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'hAlign',  hAlign);			
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'hOffset', hOffset);
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'vOffset', vOffset);
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'opacity', opacity);
				
				if (style !== "") { basicStr += makeItem(gAttribute, extraTab + '\t\t', 'style',   style); }
				
				basicStr += makeItem(gAttribute, extraTab + '\t\t', 'visible', visible);

				n = 10;
				
				if (true)	// ((objectType != "Frame") && (objectType != "Scroll Bar"))	// tooltip
				{
					var tooltip = formResults[n]; n += 1;

					if (tooltip !== "")
					{
						basicStr += makeItem(gAttribute, extraTab + '\t\t', 'tooltip', tooltip);
					}
				}
				
				if (!windowDefOpen)
				{
					var window = formResults[n]; n += 1;
					if (window !== "")
					{
						basicStr += makeItem(gAttribute, extraTab + '\t\t', 'window', window);
					}
				}
				
				if (objectType != "Scroll Bar")
				{
					var enter = formResults[n]; n += 1;

					if (enter != "0")
					{
						var temp = contextMenuItemDef(extraTab + '\t\t\t');
						while (temp !== "")
						{
							contextStr += temp;
							temp = contextMenuItemDef(extraTab + '\t\t\t');
						}
						if (contextStr !== "") { contextStr = extraTab + '\t\t<contextMenuItems>\n' + contextStr + extraTab + '\t\t</contextMenuItems>\n'; }
					}
				}
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}

			delete formfields;
			formfields = null;
			
			return basicStr;
		}

		function basicWindowDef() {
		
			var objDef = [ ['title', 'title:', 'text', [''],'','The title of this window.'],
						   ['id','id:','text', [''],'','The id of this window.'],
						   ['name','name:','text', [''],'','The name of this window.'],
						   ['width', 'width:', 'text', [''],'200','The horizontal width of this window.'],
						   ['height', 'height:', 'text', [''],'200','The vertical height of this window.'],
						   ['alignment', 'alignment:', 'popup', ['left','center','right'],'center','The  horizontal alignment of this window.'],
						   ['hOffset', 'hOffset:', 'text', [''],'0','The horizontal offset of this window.'],
						   ['vOffset', 'vOffset:', 'text', [''],'0','The vertical offset of this window.'],
						   ['opacity', 'opacity:', 'text', [''],'255','The opacity of this window.'],
						   ['style', 'style:', 'text', [''],'','The style of this window.'],
						   ['visible', 'visible:', 'popup', ['false','true'],'false','The visibility of this window.'],
						   ['tooltip', 'tooltip:', 'text', [''],'','A tooltip for this window.'] ];
						   
			var formfields = [];
			var basicStr   = "";
			    contextStr = "";	// used as a global output from this function
			
			var i = 0;
			
			for (i = 0; i < 12 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Window Definition', 'Go On');

			if (formResults !== null) {
				var title     = formResults[0];
				var id        = formResults[1];
				var name      = formResults[2];
				var width     = formResults[3];
				var height    = formResults[4];
				var alignment = formResults[5];
				var hOffset   = formResults[6];
				var vOffset   = formResults[7];
				var opacity   = formResults[8];
				var style     = formResults[9];
				var visible   = formResults[10];
				var tooltip   = formResults[11];
				

				gWidth = width;			// nasty kludge to return (image) size to some callers
				gHeight = height;

				basicStr = makeHead(gAttribute, '\t', 'window');
				
				basicStr += makeItem(gAttribute, '\t\t', 'title',     title);
				
				if (id !== "") { basicStr += makeItem(gAttribute, '\t\t', 'id',        id); }

				basicStr += makeItem(gAttribute, '\t\t', 'name',      name);
				basicStr += makeItem(gAttribute, '\t\t', 'width',     width);
				basicStr += makeItem(gAttribute, '\t\t', 'height',    height);
				basicStr += makeItem(gAttribute, '\t\t', 'alignment', alignment);			
				basicStr += makeItem(gAttribute, '\t\t', 'hOffset',   hOffset);
				basicStr += makeItem(gAttribute, '\t\t', 'vOffset',   vOffset);
				basicStr += makeItem(gAttribute, '\t\t', 'opacity',   opacity);
				
				if (style !== "") { basicStr += makeItem(gAttribute, '\t\t', 'style',     style); }

				basicStr += makeItem(gAttribute, '\t\t', 'visible',   visible);
				basicStr += makeItem(gAttribute, '\t\t', 'tooltip',   tooltip);
			}
			
			for (i = 0; i < 12 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return basicStr;
		}

		function extraWindowDef() {
		
			var objDef = [ ['level',  'level:',  'popup', ['below','normal','topMost'],'normal','The level of this window.'],
						   ['locked', 'locked:', 'popup', ['false','true'],'false','Whether this window should be locked.'],
						   ['shadow', 'shadow:', 'popup', ['false','true'],'false','Whether this window should have a shadow.'],
						   ['onFirstDisplay','onFirstDisplay:','text',[''],'','Enter a javascript statement.'],
						   ['onGainFocus','onGainFocus:','text',[''],'',''],
						   ['onLoseFocus','onLoseFocus:','text',[''],'',''],
						   ['enter','Define Menu Items','checkbox',[''],'0','Check this box if you wish to define context menu items.'] ];
						   
			var formfields = [];
			
			var basicStr = "";
			    contextStr = "";
			
			var i = 0;
			
			for (i = 0; i < 7 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}
			
			var formResults = form(formfields, 'Window Definition', 'Save');

			if (formResults !== null) {

				var level   = formResults[0];
				var locked  = formResults[1];
				var shadow  = formResults[2];
				var onFirstDisplay = formResults[3];
				var onGainFocus    = formResults[4];
				var onLoseFocus    = formResults[5];
				var enter   = formResults[6];

				basicStr += makeItem(gAttribute, '\t\t', 'level',  level);

				if (locked == 'true') { basicStr += makeItem(gAttribute, '\t\t', 'locked', locked); }
				
				basicStr += makeItem(gAttribute, '\t\t', 'shadow', shadow);
				
				if (onFirstDisplay !== "") { basicStr += makeItem(gAttribute, '\t\t', 'onFirstDisplay', onFirstDisplay); }
				if (onGainFocus    !== "") { basicStr += makeItem(gAttribute, '\t\t', 'onGainFocus',    onGainFocus);    }
				if (onLoseFocus    !== "") { basicStr += makeItem(gAttribute, '\t\t', 'onLoseFocus',    onLoseFocus);    }

				basicStr += makeNeck(gAttribute, '\t');
	
				if (enter != "0")
				{
					var temp = contextMenuItemDef('\t\t\t');
					while (temp !== "")
					{
						contextStr += temp;
						temp = contextMenuItemDef('\t\t\t');
					}
					if (contextStr !== "") { contextStr = '\t\t<contextMenuItems>\n' + contextStr + '\t\t</contextMenuItems>\n'; }
				}
			}
			
			for (i = 0; i < 7 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			return basicStr;
		}
		
		function escapePath(path) { return path.replace(/([\W])/g,'\\$1'); }

		function saveDefs() {
		
			if (frameDefOpen)  { beep(); alert("Please finish the current frame definition.");  return; }
			if (windowDefOpen) { beep(); alert("Please finish the current window definition."); return; }
			
			var widgetEnd = '</widget>\n';
			var aboutEnd = '\t</about-box>\n\n';

			var answer = "";
			
			if (widgetStr === "") { widgetEnd = ""; }
			if (aboutStr  === "") { aboutEnd  = ""; } 
		
			var totalStr = widgetStr + settingsStr + aboutStr + aboutEnd + windowStr + frameStr + 
						   canvasStr + imageStr + textStr + textAreaStr + scrollBarStr + hotkeyStr +
						   actionStr + timerStr + prefGroupStr + prefStr  + widgetEnd;

			mprint(widgetEnd);
			fragmentType = 'invalid';
			if (monitor.opacity !== 0) { monitor.data = widgetEnd; }
			
			var path = resolvePath(preferences.konFilePref.value); 	// path of .kon file - file may not exist
			
			eprint('path=' + path);
			
			var idx = path.lastIndexOf("/");
			var dir = path.substring(0,idx);						// directory in which .kon file is to be stored must exist

			if (filesystem.isDirectory(dir))						// if directory exists
			{ 
				filesystem.writeFile( path, totalStr );
				widgetPref.opacity=255;	// Brighten the Widget Definition Button
			}
			else
			{
				beep();
				answer = alert("Please specify an output file, then save again.");
				showWidgetPreferences();
			}
		}

		function eprint(theString) { if (eFlag) { print(theString); } }
		
		function mprint(theString) { if (mFlag) { print(theString); } }
			
		function sprint(theString) { if (sFlag) { print(theString); } }

		function lprint(theString) { if (lFlag) { log(theString);   } }
		
		function displayFragment(theString, fType, append)
		{
			mprint('');
			mprint(theString);
			fragmentType = fType;
			fragmentAppend = append;
			
			if (monitor.opacity !== 0) { monitor.data = theString; }
		}

		function dragDropped(image,callDef)
		{
			flash(image);
			eprint("--------------------------------------------");
			var n = system.event.data.length;
			var dropData = [];
			for (var i = 0; i < n; i += 1) { dropData[i] = system.event.data[i]; }
			
			outputFragments();

			var dropType = dropData[0];
			eprint(dropType + ":");
			if (dropType == "filenames")
			{
				for (i = 1; i < n; i += 1)
				{
					eprint("-------------------");
					var widgetPath = preferences.konFilePref.value;
					var idx = widgetPath.lastIndexOf("/");
					var dir = widgetPath.substring(0,idx);
					eprint("dir=    " + dir);
					var path = dropData[i];
					eprint("path=   " + path);
					var relPath = path;
					if (path.indexOf(dir + "/") === 0) { relPath = path.substring(idx + 1); }
					eprint("relPath=" + relPath);
					
					var isize = "0,0";
					if (isImage(path)) { isize = imageSize(path); }				// try to get image size
					
					if ( (isize == "0,0") && (system.platform == "macintosh") )		// try more elaborate methods on Macintosh
					{
						var fileData = getFileInfo(path).substr(path.length + 2);
						eprint("getFileInfo:   '" + fileData + "'");
						var item = fileData.split(" ", 2);
						var stype = item[0];
						eprint("statType:   '" + stype + "'");
						if ( (stype == 'PNG') || (stype == 'GIF') || (stype == 'JPEG') ) { isize = imageSize(path); }
					}
					
					if (isize != "0,0")
					{
						displayImageData(isize);
						callDef(isize + "," + relPath);
					}
					else { beep(); alert("File " + path + " is not an image file."); }
				}
			}
			else { beep(); }
		}

		function displayImageData(isize)
		{
			eprint('Image size: ' + isize);
			var item = isize.split(",",2);
			eprint("width:      " + item[0]);
			eprint("height:     " + item[1]);
		}

		function xtn(path)
		{
			var idx = path.lastIndexOf(".");
			if (idx >=0 )
			{
				var ext = path.substring(idx);
				if (ext.length > 1) { return ext; }
			}
			return "";
		}
		
		function isImage(path)
		{
			var xtype = xtn(path).toLowerCase();
			return ((xtype == '.jpg') || (xtype == '.gif') || (xtype == '.png'));
		}
		
		function imageSize(path)
		{
			var test = new Image();
			test.src = path;
			return test.srcWidth + "," + test.srcHeight;
		}
		
		function flash(image)
		{
			for (var i = 0; i < 2; i += 1)
			{
				image.opacity=255;
				sleep(100);
				image.opacity=128;
				sleep(100);
			}
			image.opacity=255;
			sleep(100);
		}
		
		function fetchURL(location)
		{
		 	var contents = null;
		 	var url = new URL(); 
 			contents = url.fetch(location); 
 			delete url;
 			return contents;
 		}
 		
		function makeImage(pathName, imageType, hSize, vSize)
		{
			var path = pathName;
			
			if (path[0] != "/")
			{
				var widgetPath = preferences.konFilePref.value;
				var idx = widgetPath.lastIndexOf("/");
				var dir = widgetPath.substring(0,idx);
					
				eprint("dir=" + dir);
				
				path = dir + "/" + path;
			}
			
			var idx1 = path.lastIndexOf("/");
			var dir1 = path.substring(0,idx1);
			var imageName = path.substring(idx1+1);
			
			var hfsName = convertPathToHFS(dir1);
			
			if (hfsName !== "")
			{
				hfsName += ":" + imageName;

				var vLen=hfsName.indexOf(":");
			
				eprint("-------------------");
				var spaces = "";
				for (var k = 0; k < vLen; k += 1) { spaces += " "; }
				eprint('Path:       ' + spaces + path);
				eprint('HfsName:    ' + hfsName);

				var script = '';
				script += 'tell application "GraphicConverter"\n';
				script += 'activate\n';
				script += 'set myWindow to make new window\n';
				script += 'set image dimension of myWindow to {' + hSize + ',' + vSize +'}\n';
				script += 'set image bit depth of myWindow to 32\n';
				script += 'set name of myWindow to "' + imageName + '"\n';
				script += 'set my_new_file to ("' + hfsName + '") as string\n';
				script += 'save myWindow in my_new_file as ' + imageType + ' with wwwready\n';
				script += 'close myWindow\n';
				script += 'end tell\n';
			
				lprint("Calling GraphicConverter for makeImage with timeout=10");
				var result = doScript(script, 10);
			}
			else
			{
				beep();
				alert("Widget Maker can't make " + imageName + ".\n\n Directory " + dir1 + " does not exist.");
			}
		}
		
		function startGc()
		{
			if (preferences.makeGcImagesPref.value != "0")
			{
				var script = 'tell application "GraphicConverter" to run';

				lprint("Calling GraphicConverter for startGc with timeout=10");
				var result = doScript(script, 10);
			}
		}
		
		function newWidgetDef() {
		
			var objDef = [ ['dName','Directory:','text',[''], system.userDocumentsFolder, 'The directory in which this widget is to be created (omitting following "/").'],
						   ['wName','Name:','text',[''],'My Widget','The name of this widget (without extension).'] ];
		
			var formfields = [];
			var result = "";
			var i = 0;
			
			for (i = 0; i < 2 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'New Widget Definition', 'Save');

			if (formResults !== null) {
				var dName = formResults[0];
				var wName = formResults[1];

				makeWidget(dName, wName);
				
				result = dName + '/' + wName + '/Contents/' + wName + '.kon';
			}
			
			for (i = 0; i < 2 ; i += 1)
			{
				delete formfields[i];
				formfields[i] = null;
			}
			delete formfields;
			formfields = null;
			
			eprint("konFile=" + result);
			
			return result;
		}

		function makeWidget(dName, wName) // make a new widget folder structure in directory dName with name wName
		{
			if (!filesystem.createDirectory(dName + '/' + wName)) { return false; }
			if (!filesystem.createDirectory(dName + '/' + wName + '/Contents')) { return false; }
			if (!filesystem.createDirectory(dName + '/' + wName + '/Contents/Resources')) { return false; }
			return filesystem.createDirectory(dName + '/' + wName + '/Contents/Resources/Images');
		}

		if (preferences.konFilePref.value === "") { preferences.konFilePref.value = system.userDocumentsFolder + "/widget.kon"; }


		if (system.platform != "macintosh")
		{
			preferences.makeGcImagesPref.hidden = true;
			preferences.makeGcImagesPref.value = "0";
		}
		else
		{
			preferences.makeGcImagesPref.hidden = false;
		}
		
		setDisplay();
		startGc();
		focusWidget();
